int unify_non_variables(Term *goal, Term *head) {
    /* Handle terms of different type: */
    if (goal->type != head->type) return 0;

    switch (goal->type) {
    case Is_Constant:           /* both are constants */
        return unify_constants(goal, head);
    case Is_Structure:          /* both are structures */
        return unify_structures(
            &goal->term.structure, &head->term.structure
        );
    }
}
