int unify_unbound_variable(Term *goal, Term *head) {
    /* Handle identical variables: */
    if (goal == head) {
        /* Unification of identical variables is trivial */
    }
    else {
        /* Bind the unbound variable to the other term: */
        if (head->type == Is_Variable) {
            trail_binding(head);
            head->term.variable.term = goal;
        }
        else {
            trail_binding(goal);
            goal->term.variable.term = head;
        }
    }
    return 1;       /* variable unification always succeeds */
}
