void unify_terms(Term *goal_arg, Term *head_arg, Action goal_list_tail) {
    /* Handle any bound variables: */
    Term *goal = deref(goal_arg);
    Term *head = deref(head_arg);

    if (goal->type == Is_Variable || head->type == Is_Variable) {
        unify_unbound_variable(goal, head, goal_list_tail);
    }
    else {
        unify_non_variables(goal, head, goal_list_tail);
    }
}
