/*  Recognizes characters as tokens, plus possibly [a-z] for IDENTIFIER,
    [0-9] for DIGIT, and EoF
*/

Token_Type Token;

void start_lex(void) {
}

void get_next_token(void) {
    int ch;

    while (ch = getchar(), ch == ' ' || ch == '\n') {
        /* skip garbage produced by MSDOS echo */
    }

    Token.class =
        (   ch < 0 ? EoF
#ifdef  IDENTIFIER
        :   ('a' <= ch && ch <= 'z') ? IDENTIFIER
#endif
#ifdef  DIGIT
        :   ('0' <= ch && ch <= '9') ? DIGIT
#endif
        :   ch
        );
    Token.repr = (ch < 0 ? '$' : ch);
}
