    int line_number = 1;

%%

if		return IF;
then		return THEN;
else		return ELSE;
let		return LET;
in		return IN;

\[\]		return NIL;

[0-9]+		return NUMBER;
[a-z][a-z0-9]*	return IDENTIFIER;

==		return OPERATOR;
[+\-*/<>]	return OPERATOR;

[ \t]+		{/* skip white space */}
\n		{line_number++; return *yytext;}
.		return *yytext;

%%

int yywrap(void) {
    return 1;
}
