int get_constant(Term *goal_arg, char *text) {
    /* Handle bound goal_arg: */
    Term *goal = deref(goal_arg);

    switch (goal->type) {
    case Is_Variable:
        /* Bind the goal variable to the constant: */
        trail_binding(goal);
        goal->term.variable.term = put_constant(text);
        return 1;           /* always succeeds */
    case Is_Constant:
        return strcmp(goal->term.constant, text) == 0;
    default:
        return 0;
    }
}
