int get_variable(Term **goal_ptr, Term *var) {
    /* unify *goal_ptr and unbound or bound head variable var */
    var = deref(var);   /* var may already be bound */

    if (mode == Read_Mode) {
        /* Handle bound *goal_ptr: */
        Term *goal = deref(*goal_ptr);

        if (var->type == Is_Variable) {
            trail_binding(var);
            var->term.variable.term = goal;
            return 1;
        }
        else {
            /* no further compilation possible */
            /* call interpreter */
            return unify_terms(goal, var);
        }
    }
    else {  /* mode == Write_Mode */
        *goal_ptr = var;
        return 1;
    }
}
