/* ==== Simplified translation of find_sum() ==== */
/* the type definition of the activation record of find_sum */
struct Act_Rec_find_sum {
    int sum;                    /* parameter */
};

/* the nested routine test_sum(), lifted from find_sum() */
static void find_sum_o_test_sum
    (struct Act_Rec_find_sum *act_rec_find_sum, int v1, int v2)
{
    if (v1 + v2 == act_rec_find_sum->sum) {
        printf("Solution found: %d, %d\n", v1, v2);
    }
}

/* the routine find_sum(), with explicit activation record */
void find_sum(int sum) {
    struct Act_Rec_find_sum act_rec;
    Void_Routine_Descriptor test_sum =
        {(Void_Routine)find_sum_o_test_sum, &act_rec};

    act_rec.sum = sum;

    number_pair_list(&test_sum);
}
/* ==== End of translation of find_sum() ==== */
