struct variable {
    char *name;
    struct term *term;
};

struct structure {
    char *functor;
    int arity;
    struct term **components;
};

typedef enum {Is_Constant, Is_Variable, Is_Structure} Term_Type;
typedef struct term {
    Term_Type type;
    union {
        char *constant;                 /* Is_Constant */
        struct variable variable;       /* Is_Variable */
        struct structure structure;     /* Is_Structure */
    } term;
} Term;
